from django.db import models

# Create your models here.


class Bluetooth(models.Model):
    spec = models.CharField(max_length=100)
    profile = models.CharField(max_length=100)

    def __str__(self):
       return f"Bluetooth:  {self.spec}"


class Camera(models.Model):
    class FLASHES(models.TextChoices):
        LED = 'L', 'Led'
        DUAL_LED = 'DL', 'Double Led'

    megapixel = models.DecimalField(max_digits=5, decimal_places=1)
    flash = models.CharField(max_length=100, choices=FLASHES.choices)

    def __str__(self):
       return f"Camera:  {self.megapixel} - {self.flash}"
               
#Devices.object.filter(flash=Camera.FLASEHS.LED)

                  
class Device(models.Model):
    #battery  =  <class 'dict'>
    architecture  = models.CharField(max_length=100)
    #before_install  =  <class 'dict'>
    bluetooth  =  models.ForeignKey(Bluetooth, on_delete=models.CASCADE)
    cameras  = models.ManyToManyField(Camera) 
    cpu  = models.CharField(max_length=100)
    codename  = models.CharField(max_length=100)
    cpu_cores  = models.CharField(max_length=100)
    cpu_freq  = models.CharField(max_length=100)
    #current_branch  =  <class 'float'>
    download_boot  = models.CharField(max_length=100)
    dimensions  = models.CharField(max_length=100)
    gpu  = models.CharField(max_length=100)
    image  = models.CharField(max_length=100)
    install_method  = models.CharField(max_length=100)
    kernel  = models.CharField(max_length=100)
    #maintainers  =  <class 'list'>
    #models  =  <class 'list'>
    #peripherals  =  <class 'list'>
    name  = models.CharField(max_length=100)
    recovery_boot  = models.CharField(max_length=100)
    ram  = models.CharField(max_length=100)
    recovery_reboot  = models.CharField(max_length=100)
    release  = models.CharField(max_length=100)
    #screen  =  <class 'dict'>
    #sdcard  =  <class 'dict'>
    storage  = models.CharField(max_length=100)
    soc  = models.CharField(max_length=100)
    tree  = models.CharField(max_length=100)
    type  = models.CharField(max_length=100)
    vendor  = models.CharField(max_length=100)
    vendor_short  = models.CharField(max_length=100)
    #versions  =  <class 'list'>
    wifi  = models.CharField(max_length=100)

    def __str__(self):
       return 'Device: ' + self.name